const _ = require('lodash')

const flattens = (markers, contexts) => {
  let flats = []
  for (let context of contexts) {
    const [ more, wasFlattened ] = flatten(markers, context)
    flats = flats.concat(more)
  }
  return flats
}

const accumulate = (accumulator, nexts) => {
  accumulatorPrime = []
  for (let current of accumulator) {
    for (let next of nexts) {
      const nextCurrent = _.clone(current)
      nextCurrent.push(next)
      accumulatorPrime.push(nextCurrent)
    } 
  }
  return accumulatorPrime
}

const cartesianHelper = (accumulator, b, ...c) => {
  if (b) {
    return cartesianHelper(accumulate(accumulator, b), ...c) 
  } else {
    return accumulator
  }
}

const cartesian = (...factors) => {
  return cartesianHelper([[]], ...factors)
}

const zip = (a1, a2) => {
  return a1.map(function(value, index) {
    return [value, a2[index]];
  });
}

const isArray = (value) => {
    return (!!value) && (value.constructor === Array)
};

const isObject = (value) => {
    return (!!value) && (value.constructor === Object)
};

const isCompound = (value) => {
  return isArray(value) || isObject(value)
}

const flatten_list_helper = (markers, values) => {
  let flats = []
  let wasFlattened = false
  let singles = []
  for (let value of values) {
    if (!isCompound(value)) {
      singles.push(value)
    } else {
      const [ more, wf ] = flatten(markers, value)
      if (wf) {
        wasFlattened = wasFlattened || wf
        flats.push(more)
      } else {
        singles = singles.concat(more)
      }
    }
  }

  // product does weirdness with only choice
  if (!wasFlattened) {
    return [[singles], wasFlattened]
  } else {
    let results = []
    for (let flat of cartesian(...flats)) {
      results.push(singles.concat(flat))
    }
    return [ results, wasFlattened ]
  }
}

// returns (list, wasFlattened)
const flatten = (markers, value) => {
  if (isArray(value)) {
    return flatten_list_helper(markers, value)
  }

  const marker = value.marker
  let properties = value

  // if you want to pull up conj properties fix this to do to the other part
  // split = marker in markers
  const split = markers.includes(marker)
  if (split) {
    if ('value' in properties) {
      return [properties['value'], true]
    } else {
      return [ [value], false ]
    }
  }

  let keys = []
  let valuess = []
  let unchanged = {}
  console.log('properties', JSON.stringify(properties, null, 2))
  for (let key in properties) {
    let wf = false
    let values
    // if isinstance(properties[key], Context) {
    if (isObject(properties[key])) {
      let context = properties[key];
      [values, wf] = flatten(markers, context)
    // } else if (isinstance(properties[key], list)) {
    } else if (isArray(properties[key])) {
      [values, wf] = flatten_list_helper(markers, properties[key])
    } else {
      values = [properties[key]]
    }

    if (wf) {
      keys.push(key)
      valuess.push(values)
    } else {
      unchanged[key] = values[0]
    }
  }

  let propertiess = []
  console.log('-----------> valuess', JSON.stringify(valuess)) 
  console.log('-----------> cartesian(valuess)', JSON.stringify(cartesian(valuess))) 
  // for (let values of itertools.product(*valuess)) {
  const cp = cartesian(...valuess)
  console.log('-----------> cp', JSON.stringify(cp)) 
  for (let values of cartesian(...valuess)) {
    // properties = copy.deepcopy(unchanged)
    properties = _.cloneDeep(unchanged)
    // for key, value in zip(keys, values) {
    for ( let [key, value] of zip(keys, values) ) {
      properties[key] = value
    }
    propertiess.push(properties)
  }

  return [ propertiess, valuess.length > 0 ]
}

module.exports = { flattens, flatten, cartesian, accumulate }
